﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import flash.display.Sprite;
	
    public class PlayState extends FlxState
    {
		[Embed(source = '../../data/Tiles.png')] private var ImgTiles:Class;
        [Embed(source = '../../data/tilemap.txt', mimeType = "application/octet-stream")] private var DataMap:Class;
     
		[Embed(source="../../data/arf2.mp3")] private var SndArf:Class;
		[Embed(source = "../../data/buttonpress.mp3")] private var SndPress:Class;
		[Embed(source = "../../data/teleport.mp3")] private var SndTele:Class;
		[Embed(source = "../../data/weigh.mp3")] private var SndWeigh:Class;
		[Embed(source = "../../data/noweigh.mp3")] private var SndNoWeigh:Class;
		[Embed(source = "../../data/nopuppy.mp3")] private var SndNoPuppy:Class;
		
        private var _player:Player;
		private var _caption:Caption;
		
        private var _map:FlxTilemap;
		private var _puppies:FlxArray;
		private var _nums:FlxArray;
		
        public static var lyrStage:FlxLayer;
        public static var lyrSprites:FlxLayer;
        public static var lyrHUD:FlxLayer;    

		public var _terminal:FlxSprite;
		public var _left:FlxSprite;
		public var _middle:FlxSprite;
		public var _right:FlxSprite;
		
		private var _possibleAction:String;
		
		private var _puppiesExist:Boolean;
		
		private var _messageTimer:Number;
		
		private var _probs:Array;
		private var _counts:Array;
		private var _yelpcount:int;
		private var _foundpuppy:Boolean;
		
        public function PlayState():void
        {
            super();
			_probs = new Array();
			_probs = [0, 0, 0];
			_counts = new Array();
			_counts = [0, 0, 0];
			
			_puppiesExist = false;
			_messageTimer = -1;
			
			_yelpcount = 0;
			
            lyrStage = new FlxLayer;
			lyrSprites = new FlxLayer;
            lyrHUD = new FlxLayer;
			
			_player = new Player(21, 56);
			_caption = new Caption(10, 8, _player);
			
			_terminal = new FlxSprite(null, 0 + 8, 40 + 16, false, false, 8, 8);	
			_left = new FlxSprite(null, 11 + 8, 32 + 16, false, false, 2, 1);	
			_middle = new FlxSprite(null, 19 + 8, 32 + 16, false, false, 2, 1);	
			_right = new FlxSprite(null, 27 + 8, 32 + 16, false, false, 2, 1);						
			
			lyrSprites.add(_terminal);
			
			_puppies = new FlxArray;
			_puppies.add(lyrSprites.add(new Puppy(17, 37, _player)));		
			_puppies.add(lyrSprites.add(new Puppy(33, 37, _player)));				
							
			_nums = new FlxArray;
			_nums.add(lyrSprites.add(new Digit(8+8,11+16)));				
			_nums.add(lyrSprites.add(new Digit(17+8,11+16)));				
			_nums.add(lyrSprites.add(new Digit(26+8,11+16)));				
			
            _map = new FlxTilemap(new DataMap, ImgTiles, 2);
            lyrStage.add(_map);        
			
			lyrHUD.add(_caption);
            lyrSprites.add(_player);
			
			FlxG.followBounds(8, 8, 40, 56);
			FlxG.follow(_player);
			FlxG.followAdjust(8, 8);
            //FlxG.follow(_p,2.5);
            //FlxG.followAdjust(0.5, 0.5);
            //FlxG.followBounds(1,1,640-1,480-1);

            this.add(lyrStage);
            this.add(lyrSprites);
            this.add(lyrHUD);
        }
        
        override public function update():void
        {			
            super.update();
            _map.collide(_player);
			
			if (_messageTimer > 0)
			{
				_messageTimer -= FlxG.elapsed;
				
				if (_foundpuppy)
				{
					if (_yelpcount == 0 && _messageTimer<1.6)
					{
						FlxG.play(SndArf);
						_yelpcount++;
					}
					else if (_yelpcount == 1 && _messageTimer < 1.0)
					{
						FlxG.play(SndArf);
						_yelpcount++;
					}
				}
				
				if (_messageTimer <= 0)
				{
					_yelpcount = 0;
					_puppiesExist = false;
					_puppies[0].play("invisible");
					_puppies[1].play("invisible");
					FlxG.play(SndTele);
				}
			}
			else
			{
				_possibleAction = "invisible";
				
				//test for terminal
				if (!_puppiesExist && _player.facingup == false && _player.facing == FlxG.LEFT)
				{
					_player.x -= 2;
					if (_player.overlaps(_terminal))
					{
						_possibleAction = "press";
					}
					
					_player.x += 2;
				}		
				else if (_puppiesExist && _player.facingup)
				{
					//hardcoded collisions...easier...blech
					if (_player.overlaps(_left))
					{
						_possibleAction = "openl";
					}
					else if (_player.overlaps(_right))
					{
						_possibleAction = "openr";
					}
					else if (_player.overlaps(_middle))
					{
						_possibleAction = "weigh";
					}
				}
				
				if (FlxG.justPressed(FlxG.A) || FlxG.justPressed(FlxG.B))
				{
					if (_possibleAction == "press")
					{
						spawnPuppies();
					}
					else if (_possibleAction == "openl")
					{
						checkLeft();
					}
					else if (_possibleAction == "openr")
					{
						checkRight();
					}
					else if (_possibleAction == "weigh")
					{
						weighPuppies();
					}
				}
				else
					_caption.play(_possibleAction);
				
			}
		}		
		
		private function spawnPuppies():void
		{
			_puppiesExist = true;
			FlxG.play(SndPress);			
			_puppies[0].play("box");		
			_puppies[1].play("box");
		}
		
		private function checkLeft():void
		{
			_messageTimer = 1.8;
			if (Math.random() < 0.8)
			{
				_puppies[0].play("puppy");
				_caption.play("puppy");
				_probs[0] = (_counts[0] * _probs[0] + 1) / (_counts[0] + 1);
				_counts[0]++;
				_foundpuppy = true;
				setProbLabels();
			}
			else
			{
				_caption.play("nopuppy");		
				_puppies[0].play("invisible");	
				_probs[0] = (_counts[0] * _probs[0] ) / (_counts[0] + 1);
				_counts[0]++;	
				_foundpuppy = false;
				FlxG.play(SndNoPuppy);
				setProbLabels();
			}
		}
		
		private function checkRight():void
		{
			_messageTimer = 1.8;
			if (Math.random() < 0.7)
			{
				_puppies[1].play("puppy");
				_caption.play("puppy");
				_probs[2] = (_counts[2] * _probs[2] + 1) / (_counts[2] + 1);
				_counts[2]++;
				_foundpuppy = true;
				setProbLabels();
			}
			else
			{
				_caption.play("nopuppy");		
				_puppies[1].play("invisible");	
				_probs[2] = (_counts[2] * _probs[2] ) / (_counts[2] + 1);
				_counts[2]++;	
				_foundpuppy = false;
				FlxG.play(SndNoPuppy);
				setProbLabels();
			}
		}
		
		private function weighPuppies():void
		{
			_messageTimer = 1.8;
			if (Math.random() < 0.4)
			{
				_caption.play("equal");
				_probs[1] = (_counts[1] * _probs[1] + 1) / (_counts[1] + 1);
				_counts[1]++;
				_foundpuppy = false;
				FlxG.play(SndWeigh);
				setProbLabels();
			}
			else
			{
				_caption.play("notequal");	
				_probs[1] = (_counts[1] * _probs[1] ) / (_counts[1] + 1);
				_counts[1]++;	
				_foundpuppy = false;
				FlxG.play(SndNoWeigh);
				setProbLabels();
			}
		}
		
		private function setProbLabels():void
		{
			_caption.flicker();
			
			for (var i:int = 0; i < 3; i++)
			{
				trace("count" + _counts[i]);
				if (_counts[i] > 0)
				{
					var n:int = Math.round(_probs[i] * 10);	
					trace(n.toString());
					_nums[i].play(n.toString());
				}
			}
			
		}
    }    
}