﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Player extends FlxSprite
    {
        [Embed(source='../../data/Player.png')] private var ImgPlayer:Class;
        
        private var _move_speed:int = 1000;
        private var _jump_power:int = 800;   
        private var _max_health:int = 10;
        private var _hurt_counter:Number = 0;
		
		private var inventorychanged:Boolean = false;
		
		public var facingup:Boolean;
		
        public function Player(X:Number,Y:Number):void
        {
            super(ImgPlayer, X, Y, true, true);//Max speeds
            maxVelocity.x = 50;
            maxVelocity.y = 50;
            //Set the player health
            health = 10;
            //Gravity
            acceleration.y = 0;            
            //Friction
            drag.x = 500;
            drag.y = 500;
            //bounding box tweaks
            width = 6;
            height = 7;
            offset.x = 1;
            offset.y = 1;
			facing = false;
			addAnimation("down", [0]);
            addAnimation("up", [1]);
			play("down");		
        }
    
        override public function update():void
        {

            if(dead)
            {
                if(finished) exists = false;
                else
                    super.update();
                return;
            }

            if(FlxG.kLeft)
            {
                velocity.x -= _move_speed * FlxG.elapsed;
				play("down",true);								
				facing = false;
            }
            if (FlxG.kRight)
            {
                velocity.x += _move_speed * FlxG.elapsed; 
				play("down",true);								
				facing = true;           
            }
			if (FlxG.kUp)
			{
				velocity.y -= _move_speed * FlxG.elapsed;
				play("up", true);
			}
			if (FlxG.kDown)
			{
				velocity.y += _move_speed * FlxG.elapsed;
				play("down",true);				
			}
            super.update();
        }
		
		override public function play(AnimName: String, Force: Boolean = false):void
		{
			if (AnimName == "up")
				facingup = true;
			else if (AnimName == "down")
				facingup = false;
				
			super.play(AnimName, Force);
		}
		
    }	
}